// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,245);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;

    //Mod1State state;
    public Button bupdate;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        //int buttonx = 800;
        //int buttony = 190;
        int buttonx = 400;
        int buttony = 400;
        
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        int vpos = 25;
        int hpos = 15;
        int deltaY = 25;
        int deltaY2 = 20;
        int deltaY3 = 40;
        
        g.drawString("Instructions", hpos,vpos);
        
        vpos+=deltaY;
        
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("This module provides information about TE and "+
                    "TM modes in a metal",hpos,vpos);
                    
        vpos+=deltaY2;
        g.drawString("rectangular waveguide.",hpos,vpos);
        
        vpos+=deltaY;
        
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        //g.drawString("Input", 15,50);
        g.drawString("Input", hpos,vpos);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        vpos+=deltaY;
        //INPUT
        String s = "\u2022 Waveguide dimensions a and b";
        int nextX = STR.displayString(s,g,hpos,vpos);
        s = "\u2022 TE or TM mode";
        vpos+=deltaY;
        nextX = STR.displayString(s,g,15,vpos);
        s = "\u2022 frequency  f";
        vpos+=deltaY;
        nextX = STR.displayString(s,g,15,vpos);
        s = "\u2022 \u03b5"+STR.SUB+"r"+STR.ENDSUB+" of dielectric material";
        vpos+=deltaY;
        nextX = STR.displayString(s,g,15,vpos);
       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        //int newY = 115+5*deltaY+40;
        //int newY = 70;
        //int newX = 300;
        
        vpos+=deltaY;
        g.drawString("Displayed Information", hpos,vpos);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        vpos+=deltaY;
        s = "\u2022 Cutoff frequencies of TE and TM modes";
        nextX = STR.displayString(s,g,hpos,vpos);
        vpos+=deltaY;
        s = "\u2022 Spatial distribution of "+STR.BOLD+"E"+STR.ENDBOLD+" for "+
            "TE modes and "+STR.BOLD+"H"+STR.ENDBOLD+" for TM modes";
        nextX = STR.displayString(s,g,hpos,vpos);
        vpos+=deltaY;
        s = "\u2022 Phase and group velocities";
        nextX = STR.displayString(s,g,hpos,vpos);
        
        g.setFont(new Font("SanSerif",Font.PLAIN,12));
        vpos+=deltaY+10;
        s = "The Mode Spectrum panel only displays cutoff frequencies of lower order modes.";
        nextX = STR.displayString(s,g,hpos,vpos);
        
        vpos+=deltaY2;
        s = "Use Mode Selector to scan higher order modes in the Mode Properties panel.";
        nextX = STR.displayString(s,g,hpos,vpos);
        vpos+=deltaY2;
        s = "";
        nextX = STR.displayString(s,g,hpos,vpos);
        
        drawCopyRight(g);
        
        //MaestroG.subscripter("Higher order modes are listed in the Mode Properties panel ( use Mode Selector to scan modes )","","",g,10,20, getSize().height-10);

        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("  Applet Design: Umberto Ravaioli",
                     startingX,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "  Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("  All Rights Reserved",startingX,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+lineLength+10,startingY+5);
        g.drawLine(startingX+lineLength+10,startingY+5,
                   startingX+lineLength+10,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

